<?php
if (!class_exists('vBShop_Item_Core'))
{
	die('No direct access allowed.');
}

class vBShop_Item_autobump extends vBShop_Item_Core
{	
	/**
	* The constructor
	*
	* @param	vBulletin	vBulletin registry
	* @param	array		Item info
	*/	
	public function __construct(&$registry, &$item)
	{
		parent::__construct($registry, $item);
		
		// Set purchase template
		$this->config['purchasetemplate'] = 'dbtech_vbshop_configure_threadbump';
	}
	
	/**
	* Function to call before every action
	*/	
	public function action()
	{
		if (!parent::action())
		{
			// This type is inactive
			return false;
		}
		
		// We made it!
		return true;
	}

	/**
	* Prints out an AdminCP form
	*/	
	public function print_admin_form($code)
	{
		global $vbphrase;
		
		print_input_row($vbphrase['dbtech_vbshop_interval_autobump'], 	'item[code][interval]', 		$code['interval']);
	}

	/**
	* Configure an item
	*
	* @param	integer		Purchase ID
	* @param	mixed		Recipient
	*/	
	public function configure($purchaseid, $recipient = null)
	{
		global $vbphrase;
		
		if (!$this->can_configure($purchaseid))
		{
			// Can't configure this item
			return false;
		}
		
		// Ensure this is set
		$recipient = (!$recipient ? $this->registry->userinfo : $recipient);
		
		// Get the form code
		$code 			= $this->registry->input->clean_gpc('p', 'code', 			TYPE_ARRAY);
		$noConfigure 	= $this->registry->input->clean_gpc('p', '_noConfigure', 	TYPE_BOOL);
		
		if ($noConfigure)
		{
			// We're done, we wanted to let the recipient configure it themselves
			return true;
		}
		
		$values = array();
		foreach ($code as $style => &$value)
		{
			$output = $value;
			if (is_numeric($value))
			{
				if ($value == 0)
				{
					$output = $vbphrase['no'];
				}
				else if ($value == 1)
				{
					$output = $vbphrase['yes'];
				}				
			}
			else if (!$value)
			{
				$output = 'N/A';
			}
			else
			{
				$output = $value = preg_replace('/[^A-Za-z0-9 #(),]/', '', $value);
			}
			
			// Set the values
			$values[] = $vbphrase['dbtech_vbshop_' . $style] . ': ' . $output;
		}
		if ($this->config['notifications_config'])
		{
			$userids = explode(',', $this->config['notifications_config']);
			foreach ((array)$userids as $userid)
			{
				// Send PM
				VBSHOP::sendPM(
					$userid,
					construct_phrase($vbphrase['dbtech_vbshop_new_configuration_x'],
						$this->config['title']
					),
					construct_phrase($vbphrase['dbtech_vbshop_x_just_configured_y'],
						$recipient['username'],
						$this->config['title'],
						implode("\n", $values)
					)
				);
			}
		}
		
		// Update flag
		$this->registry->db->query_write("
			UPDATE " . TABLE_PREFIX . "dbtech_vbshop_purchase
			SET configuration = " . $this->registry->db->sql_prepare(trim(serialize($code))) . "
			WHERE purchaseid = " . intval($purchaseid) . "
		");
		
		// Build purchase cache
		VBSHOP::build_purchases($recipient);
	}

	/**
	* Bump a thread
	*/	
	public function autoBump()
	{
		if (!$this->config['active'])
		{
			// We're not doin this
			return false;
		}

		if (!$this->config['configuration']['contentid'])
		{
			// We're not doin this
			return false;
		}

		// Fetch our thread info
		$threadinfo = fetch_threadinfo($this->config['configuration']['contentid']);
		$foruminfo = fetch_foruminfo($threadinfo['forumid']);

		if ($threadinfo['lastpost'] > (TIMENOW - ($this->config['code']['interval'] * 3600)))
		{
			// Thread is still new
			return false;
		}

		$thread =& datamanager_init('Thread', $this->registry, ERRTYPE_SILENT, 'threadpost');
			$thread->set_existing($threadinfo);
			$thread->set_info('forum', $foruminfo);
			$thread->set('lastpost', TIMENOW);
		$thread->save();

		$forumdata =& datamanager_init('Forum', $this->registry, ERRTYPE_SILENT);
			$forumdata->set_existing($foruminfo);
			$forumdata->set('lastpost', TIMENOW);
			$forumdata->set('lastthread', $threadinfo['title']);
			$forumdata->set('lastthreadid', $threadinfo['threadid']);
		$forumdata->save();
	}
}
?>